#include <View.h>
#include <stdio.h>
#include "HistoryList.h"
#include "Counter.h"

extern BApplication *be_app;

HistoryList::HistoryList(int32 c,tm *st,int32 dt,float pr,int32 type,bool fixedprice)
: BListItem()
{
	_connection = c;
	_starttime = *st;
	_duringtime = dt;
	_money = pr;
	_drawingmode = type;
	_fixedprice = fixedprice;
}

HistoryList::HistoryList(HistoryList &copy)
{
	_connection = copy._connection;
	_starttime = copy._starttime;
	_duringtime = copy._duringtime;
	_money = copy._money;
	_drawingmode = copy._drawingmode;		
	_fixedprice = copy._fixedprice;
}

HistoryList::~HistoryList()
{
}

void HistoryList::DrawItem(BView *owner,BRect frame,bool complete)
{
	CounterApp	*_app = (CounterApp *)be_app;
	static char	buffer[50];
	int32		h,m,s;
	rgb_color	OldColor;
	rgb_color	OldLowColor;

	OldColor = owner->HighColor();
	OldLowColor = owner->LowColor();
	
	if(IsSelected())
		owner->SetHighColor(200,200,255,255);
	else
		owner->SetHighColor(255,255,255,255);	
	owner->SetLowColor(owner->HighColor());	
	owner->FillRect(frame);

	owner->SetHighColor(_app->ColorStandard());
	if(_fixedprice && _drawingmode==DETAILS)
		owner->SetHighColor(_app->ColorFixed());
	
	sprintf(buffer,"%03ld",_connection);
	owner->DrawString(buffer,BPoint(frame.left+5, frame.bottom - 2));
	owner->SetHighColor(_app->ColorDate());
	if (_drawingmode==DETAILS)
		strftime(buffer,50,"%A %d %B %Y",&_starttime);
	else
		strftime(buffer,50,"%B %Y",&_starttime);
	
	owner->DrawString(buffer,BPoint(frame.left+30, frame.bottom - 2));	
	owner->SetHighColor(_app->ColorTime());
	strftime(buffer,10,"%H:%M:%S",&_starttime);
	owner->DrawString(buffer,BPoint(frame.left+193, frame.bottom - 2));	
	h = _duringtime / 3600;
	m = (_duringtime % 3600) / 60;
	s = _duringtime % 60;
	sprintf(buffer,"%02ld:%02ld:%02ld",h,m,s);
	owner->DrawString(buffer,BPoint(frame.left+243, frame.bottom - 2));
	owner->SetHighColor(_app->ColorPrice());
	sprintf(buffer,"%.2f",_money);
	owner->DrawString(buffer,BPoint(frame.left+293, frame.bottom - 2));

	owner->SetHighColor(OldColor);
	owner->SetLowColor(OldLowColor);
}