#include "CColorLabel.h"
#include "Constants.h"
#include <Window.h>

//rgb_color	RectColor;

CColorLabel::CColorLabel(BRect frame,const char *name,const char * label,BMessage *message)
: BControl(frame,name,label,message,B_FOLLOW_ALL_SIDES, B_WILL_DRAW)
{
	_rectColor = U_COLOR_GRAY2;
}

CColorLabel::~CColorLabel(void)
{
}

void CColorLabel::Draw(BRect updateRect)
{
	BRect frame = Bounds();
	
	DrawString(Label(),BPoint(frame.left + 5,frame.bottom - 5));

	frame.left = frame.right - 20;

	// draw rectangle
	BeginLineArray(8);
	AddLine(BPoint(frame.right,frame.top),BPoint(frame.right,frame.bottom),U_COLOR_WHITE);
	AddLine(BPoint(frame.left,frame.bottom),BPoint(frame.right,frame.bottom),U_COLOR_WHITE);
	AddLine(BPoint(frame.right-1,frame.top+1),BPoint(frame.right-1,frame.bottom-1),U_COLOR_GRAY1);
	AddLine(BPoint(frame.left+1,frame.bottom-1),BPoint(frame.right-1,frame.bottom-1),U_COLOR_GRAY1);
	AddLine(BPoint(frame.left,frame.top),BPoint(frame.right,frame.top),U_COLOR_GRAY2);
	AddLine(BPoint(frame.left,frame.top),BPoint(frame.left,frame.bottom),U_COLOR_GRAY2);
	AddLine(BPoint(frame.left+1,frame.top+1),BPoint(frame.right-1,frame.top+1),U_COLOR_GRAY3);
	AddLine(BPoint(frame.left+1,frame.top+1),BPoint(frame.left+1,frame.bottom-1),U_COLOR_GRAY3);
	EndLineArray();

	// draw fill rectangle
	SetHighColor(_rectColor);
	FillRect(BRect(frame.left+2,frame.top+2,frame.right-2,frame.bottom-2));
}

void CColorLabel::MessageReceived(BMessage* msg)
{
	if (msg->WasDropped())
	{
		// handle roColour drag&drop
		const rgb_color *color;
		ssize_t size;
		if (msg->FindData("RGBColor", 'RGBC',reinterpret_cast<const void **>(&color), &size) == B_OK)
		{	
			BMessage *drop = Message();
			_rectColor = *color;
			Invalidate();
			(BMessenger(Target())).SendMessage(drop);
		}
	}
	else
	{
		switch(msg->what)
		{
		default:
			BControl::MessageReceived(msg);
		}
	}
}