#include <iostream.h>
#include "CNumberScroll.h"


/*** colors constant ***/
const rgb_color			CNS_WHITE_COLOR = {255,255,255,255};
const rgb_color			CNS_GRAYH_COLOR = {195,195,195,255};
const rgb_color			CNS_GRAYM_COLOR = {154,154,154,255};
const rgb_color			CNS_GRAYL_COLOR = {89,89,89,255};

CNumberScroll::CNumberScroll(BRect frame,const char *name,BMessage *message,int32 valMin, int32 valMax)
: BControl(frame,name,"",message,B_FOLLOW_ALL_SIDES, B_WILL_DRAW)
{
	_valMax = valMax;
	_valMin = valMin;
	SetValue(_valMin);
	message->AddInt32("_val",_valMin);
	SetViewColor(219,219,219);
}

CNumberScroll::~CNumberScroll(void)
{
}

void CNumberScroll::SetMaxValue(int32 value)
{
	_valMax = value;
	if(Value() > _valMax)
	{
		BMessage	*message = Message();

		SetValue(_valMax);
		message->ReplaceInt32("_val",_valMax);
		(BMessenger(Target())).SendMessage(message);
	}
}

void CNumberScroll::SetMinValue(int32 value)
{
	_valMin = value;
	if(Value() < _valMin)
	{
		BMessage	*message = Message();

		SetValue(_valMin);
		message->ReplaceInt32("_val",_valMin);
		(BMessenger(Target())).SendMessage(message);
	}
}

void CNumberScroll::Draw(BRect updateRect)
{
	BRect		boundRect;
	int32		x1,x2,x3;
	int32		y1,y2,y3,y4;
	rgb_color	oldcolor;
	rgb_color	oldlowcolor;
	rgb_color	tmpGray;

	boundRect = Bounds();
	x1 = (int32)boundRect.right / 4;
	x2 = (int32)boundRect.right / 2;
	x3 = x2 + x1 +1;
	y1 = (int32)boundRect.bottom / 4 -1;
	y2 = (int32)boundRect.bottom / 2 -1;
	y3 = y2 +2;
	y4 = y3 + y1 +2;
	
	oldcolor = HighColor();
	oldlowcolor = LowColor();

	SetHighColor(219,219,219);
	tmpGray = CNS_GRAYM_COLOR;
	if(!IsEnabled())
	{
		SetHighColor(239,239,239);
		tmpGray = CNS_GRAYH_COLOR;
	}
	FillRect(boundRect);
	SetHighColor(CNS_GRAYM_COLOR);
	StrokeRect(boundRect);

	boundRect.InsetBy(1,1);
	BeginLineArray((IsEnabled())?17:10);
	AddLine(BPoint(boundRect.left,boundRect.top),BPoint(boundRect.left,boundRect.bottom),CNS_WHITE_COLOR);
	AddLine(BPoint(boundRect.right,boundRect.top),BPoint(boundRect.right,boundRect.bottom),CNS_GRAYH_COLOR);
	AddLine(BPoint(boundRect.left,boundRect.top),BPoint(boundRect.right,boundRect.top),CNS_WHITE_COLOR);
	AddLine(BPoint(boundRect.left,boundRect.bottom),BPoint(boundRect.right,boundRect.bottom),CNS_GRAYH_COLOR);
	// first triangle
	AddLine(BPoint(x2,y1),BPoint(x1,y2),tmpGray);
	AddLine(BPoint(x1,y2),BPoint(x3,y2),tmpGray);
	AddLine(BPoint(x3,y2),BPoint(x2,y1),tmpGray);
	// second triangle
	AddLine(BPoint(x1,y3),BPoint(x3,y3),tmpGray);
	AddLine(BPoint(x3,y3),BPoint(x2,y4),CNS_GRAYH_COLOR);
	AddLine(BPoint(x2,y4),BPoint(x1,y3),tmpGray);
	// first triangle relief
	AddLine(BPoint(x2+1,y1),BPoint(x3+1,y2),CNS_GRAYL_COLOR);
	AddLine(BPoint(x1+1,y2+1),BPoint(x3+1,y2+1),CNS_GRAYL_COLOR);
	AddLine(BPoint(x2,y1+1),BPoint(x1+2,y2-1),CNS_WHITE_COLOR);
	AddLine(BPoint(x1+3,y2-1),BPoint(x3-2,y2-1),CNS_GRAYH_COLOR);
	// second triangle relief
	AddLine(BPoint(x3+1,y3),BPoint(x2+1,y4),CNS_GRAYL_COLOR);
	AddLine(BPoint(x3+1,y3+1),BPoint(x2+1,y4+1),CNS_GRAYM_COLOR);
	AddLine(BPoint(x1+2,y3+1),BPoint(x3-2,y3+1),CNS_WHITE_COLOR);
	EndLineArray();

	SetLowColor(oldlowcolor);
	SetHighColor(oldcolor);
}

void CNumberScroll::MouseDown(BPoint point)
{
	int32	valuePos;

	valuePos = Value();
	if(IsEnabled())
	{
		BMessage	*message = Message();
	
		// decrease
		if(point.y < ((Bounds()).bottom / 2))
		{
			if(valuePos < _valMax)
				valuePos++;
		}
		// increase
		else
		{
			if(valuePos > _valMin)
				valuePos--;
		}
		SetValue(valuePos);
		message->ReplaceInt32("_val",valuePos);
		(BMessenger(Target())).SendMessage(message);
	}
}