#include <Font.h>
#include "CColorMenuItem.h"

CColorMenuItem::CColorMenuItem(BString label,BMessage *message,char shortcut, uint32 modifiers)
: BMenuItem(label.String(),message,shortcut,modifiers)
{
	SetRectColor(0,0,0);
}

CColorMenuItem::CColorMenuItem(rgb_color menucolor,BString label,BMessage *message,char shortcut, uint32 modifiers)
: BMenuItem(label.String(),message,shortcut,modifiers)
{
	SetRectColor(menucolor);
}

CColorMenuItem::~CColorMenuItem(void)
{
}

void CColorMenuItem::GetContentSize(float *heigth,float *weight)
{
	BMenuItem::GetContentSize(heigth,weight);
	weight += int(_infoFontMenu.ascent *1.25);
	_menuAttached = Menu();
	_menuAttached->GetFontHeight(&_infoFontMenu);
}

void CColorMenuItem::Draw(void)
{
	rgb_color	OldColor;
	rgb_color	OldLowColor;
	rgb_color	color;
	
	_itemFrame = Frame();
	_itemFrame.left += int(_infoFontMenu.ascent *1.25);
	_itemFrame.top += int(_infoFontMenu.descent);
	_itemFrame.right = _itemFrame.left + int(_infoFontMenu.ascent);
	_itemFrame.bottom = _itemFrame.top + int(_infoFontMenu.ascent);

	OldColor = _menuAttached->HighColor();
	OldLowColor = _menuAttached->LowColor();

	_menuAttached->SetHighColor(156,156,156,255);
	if(IsSelected())
	{
		_menuAttached->FillRect(Frame());
		_menuAttached->SetLowColor(_menuAttached->HighColor());
	}
	_menuAttached->SetHighColor(OldColor);
	DrawContent();
	
	_menuAttached->SetHighColor(_rectColorItem);
	_menuAttached->FillRect(_itemFrame);

	_menuAttached->BeginLineArray(4);
	_menuAttached->SetHighColor(220,220,220,255);
	color = _menuAttached->HighColor();
	_menuAttached->AddLine(BPoint(_itemFrame.left,_itemFrame.top),BPoint(_itemFrame.right,_itemFrame.top),color);
	_menuAttached->AddLine(BPoint(_itemFrame.left,_itemFrame.top),BPoint(_itemFrame.left,_itemFrame.bottom),color);
	_menuAttached->SetHighColor(110,110,110,255);
	color = _menuAttached->HighColor();
	_menuAttached->AddLine(BPoint(_itemFrame.right,_itemFrame.top),BPoint(_itemFrame.right,_itemFrame.bottom),color);
	_menuAttached->AddLine(BPoint(_itemFrame.left,_itemFrame.bottom),BPoint(_itemFrame.right,_itemFrame.bottom),color);
	_menuAttached->EndLineArray();
	
	_menuAttached->SetHighColor(OldColor);
	_menuAttached->SetLowColor(OldLowColor);
}

void CColorMenuItem::DrawContent(void)
{
	BPoint	coordcontent;
	
	coordcontent = ContentLocation();
	coordcontent.x += (_infoFontMenu.ascent *1.50);
	coordcontent.y += _infoFontMenu.ascent;
	_menuAttached->DrawString(Label(),coordcontent);
}

void CColorMenuItem::SetRectColor(rgb_color color)
{
	_rectColorItem = color;
}

void CColorMenuItem::SetRectColor(int red,int green,int blue,int alpha)
{
	_rectColorItem.red = red;
	_rectColorItem.green = green;
	_rectColorItem.blue = blue;
	_rectColorItem.alpha = alpha;
}
