/*******************************************************/
/* fenetre pour fixer les preferences de l'application */
/*******************************************************/
#include "PrefAppWindow.h"

/**** Constructor ****/
PrefAppWindow::PrefAppWindow(BRect frame,const char *name,BMessenger messenger,window_look winlook)
: BWindow(frame,name,B_TITLED_WINDOW, B_NOT_RESIZABLE | B_NOT_ZOOMABLE )
{	
	countermessenger = messenger;

	SetLook(winlook);
	SetFeel(B_NORMAL_WINDOW_FEEL);

	firstview = new PrefAppView(Bounds());
	AddChild(firstview);
}

/**** Destructor ****/
PrefAppWindow::~PrefAppWindow(void)
{
}

/**** MessageReceived method ***/
void PrefAppWindow::MessageReceived(BMessage *message)
{
	switch(message->what)
	{
		case U_REFRESH_SETTINGS_MSG:
			(BMessenger(firstview)).SendMessage(message);
			break;
		default:
			BWindow::MessageReceived(message);
	}
}

/**** QuitRequested ****/
bool PrefAppWindow::QuitRequested(void)
{
	BRect		framefenetre = Frame();
	BMessage	msgtoclose(CLOSE_WIN_PREF_APP);
	
	msgtoclose.AddData("fenetre-pref-app",B_RECT_TYPE,&framefenetre,sizeof(framefenetre));
	countermessenger.SendMessage(&msgtoclose);

	return(true);
}